#include <iostream>
#include <list>
#include <string>
using namespace std;

#include "instruction.h"
#include "scanner.h"
#include "parser.h"

typedef list<Instruction*>		INSTRUCTION_LIST;
typedef list<Instruction*>::iterator	INSTRUCTION_ITERATOR;

int main()
{
	If	if1("if1"), if2("if2");
	Assign	ass1("ass1"), ass2("ass2");
	Repeat	rpt1("rpt1"), rpt2("rpt2");
	Read	rd1("rd1"), rd2("rd2");
	Write	wr1("wr1"), wr2("wr2");

	INSTRUCTION_LIST	inst_list;
	INSTRUCTION_ITERATOR	ite;

	Scanner	scanner;
	Parser	parser;

	inst_list.push_back(&if1);
	inst_list.push_back(&ass1);
	inst_list.push_back(&rpt1);
	inst_list.push_back(&rd1);
	inst_list.push_back(&wr1);

	inst_list.push_back(&wr2);
	inst_list.push_back(&rd2);
	inst_list.push_back(&rpt2);
	inst_list.push_back(&ass2);
	inst_list.push_back(&if2);

	// output in scanner's format
	for (ite=inst_list.begin(); ite!=inst_list.end(); ite++)
	{
		(*ite)->Accept(&scanner);
	}

	// output in parser's format
	for (ite=inst_list.begin(); ite!=inst_list.end(); ite++)
	{
		(*ite)->Accept(&parser);
	}
}

